<template>
    <div id="idPokemon">

        <div class="card">
        <div class="card-image">
            <figure>
            <img :src="dtCurrentUrlImg" alt="Placeholder image">
            </figure>
        </div>
        <div class="card-content">
            <div class="media">

            <div class="media-content">
                <p class="title is-4">{{propNum}} {{propName | captalize}}</p>
                <p class="subtitle is-6">{{dtPokemon.type}}</p>
            </div>
            </div>

            <div class="content">
                <button class="button is-medium is-fullwidth" @click="mudarSprite">Mudar Sprite</button>
            </div>
        </div>
        </div>

    </div>
</template>

<script>
import axios from 'axios';

export default {
    created: function(){
        //As props sao carregadas em App.js, porém é possível asserar os dados contídos nelas daqui.
        //Sendo assim, é possssível utilizar a prop url carregada em App.js
        axios.get(this.propUrl).then(res => {
            
            //criar type em dtPokemon
            this.dtPokemon.type = res.data.types[0].type.name;

            //criar front em dtPokemon
            this.dtPokemon.front = res.data.sprites.front_default;

            //criar back em dtPokemon
            this.dtPokemon.back = res.data.sprites.back_default;

            // Carrega a url da imagem atual
            this.dtCurrentUrlImg = this.dtPokemon.front;

            console.log(this.dtPokemon);
        });
    },
    data(){
        return{
            dtIsFront: true,
            dtCurrentUrlImg: '',
            dtPokemon: {
                type: '',
                front: '',
                back: ''
            }
        }
    },
    props: {
        propNum: Number,
        propName: String,
        propUrl: String
    },
    filters: {
        captalize: function(value){
            var CaptalizedStr = value.charAt(0).toUpperCase() + value.slice(1);
            return CaptalizedStr;
        }
    },
    methods: {
        mudarSprite: function(){
            if(this.dtIsFront){
                this.dtCurrentUrlImg = this.dtPokemon.back;
            }else{
                this.dtCurrentUrlImg = this.dtPokemon.front;
            }
            this.dtIsFront = !this.dtIsFront;
        }
    }
}
</script>

<style>
    #idPokemon{
        margin-top: 1%;
    }
</style>